<?php
/****************************************************************
*	Read folder and make links from content (files)
*****************************************************************
*
*	SOFTWARE LICENSE: GPL
*	Copyright (C) 2011 Hans-Georg Bork (hgb@users.sourceforge.net)
*
* This script is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License 
* as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
* 
* This script is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this script; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
* or check http://www.gnu.org/licenses/ for more information.
*
*/

if( count( get_included_files() ) == 1 ) : die( "Access denied" ); endif;
// 			Change following variables when copying file !!
$title = "Your own title in readfolder.php";
$description = "$title - and your name if you like";
$explanation = "... and you might want to tell which files are found here";

echo "
	<html>
		<head>
			<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">
			<META NAME=\"GENERATOR\" CONTENT=\"PHP scripting\">
			<META NAME=\"Author\" CONTENT=\"Hans-Georg Bork (hgb@users.sourceforge.net)\">
			<META NAME=\"Description\" CONTENT=$description>
			<title>$title</title>
			<style type=\"text/css\">
				<!--
					.style1 {
						font-size: 16px;
						font-weight: bold;
						font-family: Georgia, \"Times New Roman\", Times, serif;
					}
					.style2 {
						color: #666;
						font-size: 14px;
					}
					.style3 {
						font-family: Georgia, \"Times New Roman\", Times, serif;
						color: #666;
						font-size: 14px;
					}
				-->
			</style>
		</head>
		<body>
			<h2 align=\"center\" class=\"style1\">$title</h2>
			<p class=\"style3\">$explanation</p>

";

function ReadFolder( $pfile ) {
global $extension;
global $rows_per_col;
global $rows;
global $foldername;

//        if(substr( $pfile,strlen($extension)*(-1)) == $extension && is_numeric(substr( $pfile,(strlen($extension)+1)*(-1),1)) ) {
        if( !is_dir( $pfile ) && substr( $pfile,strlen($extension)*(-1)) == $extension ) {

//	BEGIN: Use filename to get link
//		$pfile_arr = explode( $extension , $pfile );
//		$filetitle = $pfile_arr[0];
		$filetitle = basename( $pfile , $extension );
//	END: Use filename to get link

		echo "
			<ul class=\"style2\">
				<li class=\"style1\">
					<span class=\"style3\">
						<A HREF=\"?do=play&mp3=$pfile&foldername=$foldername\">$filetitle</A> <a href=\"$pfile\"><img src=\"download.png\" border=0 height=12 width=12 alt=\"Download\" title=\"Download $filetitle\" /></a> 
					</span>
				</li>
			</ul>
		";
//						<A HREF=\"?do=play&mp3=$foldername/$pfile&foldername=$foldername\">$filetitle</A> <a href=\"$foldername/$pfile\"><img src=\"download.png\" border=0 height=12 width=12 alt=\"Download\" title=\"Download $filetitle\" /></a> 
		$rows++;
		if( ($rows % $rows_per_col) == 0 ) {
			echo "      </p>\n    </td>\n    <td>\n      <p align=\"center\">\n";
		}
		
        }

	if( is_dir( $pfile ) ) {
		$filetitle = basename( $pfile );
		echo "
			<ul class=\"style2\">
				<li class=\"style1\">
					<span class=\"style3\">
						<A HREF=\"?do=readfolder&foldername=$pfile\">$filetitle</A> 
					</span>
				</li>
			</ul>
		";
//						<A HREF=\"?do=readfolder&foldername=$foldername/$filetitle\">$filetitle</A> 
		$rows++;
		if( ($rows % $rows_per_col) == 0 ) {
			echo "      </p>\n    </td>\n    <td>\n      <p align=\"center\">\n";
		}
	}
}

$files = array();
$i = 0;

$whereweare = substr( $foldername , 1 );

// echo "<table width=\"632\" border=0 height=6 align=\"center\">\n";
echo "<table border=0 height=6 align=\"center\">\n";
echo "  <tr><!-- Row 1 -->\n";
echo "    <td>\n";
echo "      <p align=\"center\">$whereweare\n";
      
	$folder = dir($foldername);
	while($fn = $folder->read()) {
		$filename = "$foldername/$fn";

//    	  if( !is_dir( $filename ) && substr( $filename , -1 ) != "." ) {
		if( substr( $filename , -1 ) != "." ) {
			if( is_dir( $filename ) ) {
				$files[$i] = "*$filename";
			} else {
				$files[$i] = $filename;
			}
			$i++;
		}
	}
	$folder->close();

// Sort filenames to have newest first
	sort( $files );

	foreach( $files as $key => $filename ) {

		if( $filename[0] == "*" ) {
			ReadFolder( substr( $filename , 1 ) );
		} else {
			ReadFolder( $filename );
		}
	}

echo "      </p>\n";
echo "    </td>\n";
echo "  </tr>\n";
echo "</table>\n";

?>
