<?php
/****************************************************************
*	index.php to provide a html skeleton in which other scripts
* 	are included
*****************************************************************
*
*	SOFTWARE LICENSE: GPL
*	Copyright (C) 2011 Hans-Georg Bork (hgb@users.sourceforge.net)
*
* This script is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License 
* as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
* 
* This script is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this script; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
* or check http://www.gnu.org/licenses/ for more information.
*
*/

$path = ".";

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  This is a fix if register_globals is turned off
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
if(!$PHP_SELF){
	if($HTTP_POST_VARS) 	{extract($HTTP_POST_VARS, EXTR_PREFIX_SAME, "post_");}
	if($HTTP_GET_VARS)  	{extract($HTTP_GET_VARS, EXTR_PREFIX_SAME, "get_");}
	if($HTTP_COOKIE_VARS)	{extract($HTTP_COOKIE_VARS, EXTR_PREFIX_SAME, "cookie_");}
	if($HTTP_ENV_VARS)	 	{extract($HTTP_ENV_VARS, EXTR_PREFIX_SAME, "env_");}
}
if($PHP_SELF == ""){ $PHP_SELF = $HTTP_SERVER_VARS[PHP_SELF]; }

?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Add your own title in index.php</title>
<style>
<!--
	A 			{ color: #003366; text-decoration: none; }
	A:link		{ color: #003366; text-decoration: none; }
	A:visited	{ color: #003366; text-decoration: none; }
	A:active	{ color: #54622D;  }
	A:hover	{ color: #54622D;  }


BODY,TD,TR{
		font-family: verdana, arial, sans-serif;
		color:#000;
		font-size:11;
		font-weight:normal;
}
.banner {
	font-family: georgia, verdana, arial, sans-serif;
	color:white;
	font-size:x-large;
	font-weight:bold;
	border-left:1px solid #FFF;
	border-right:1px solid #FFF;
	border-top:1px solid #FFF;
	background:##FFFFCC;
	padding:7px;
}
.description{
	font-family:verdana, arial, sans-serif;
	font-size:x-small;
	font-weight:bold;
}

//body,td,th {
	font-size: 11px;
}
body {
	background-color: #000066;
}
body,td,th {
	font-size: 11px;
}
.style2 {font-family: verdana, arial, sans-serif; font-size: 24px; font-weight: bold; }
-->
</style>
</head>
	<body>
		<div align="center">
			<table border="0" width="1200" cellspacing="0" cellpadding="0">
				<tr>
					<td>
						<table width="100%" border="0" cellpadding="6" cellspacing="0" bgcolor="#FFFFCC">
							<tr>
								<!-- <td width="151" valign="top" style="border-right: 1px dotted #000000;"> -->
								<td width="200" valign="top" style="border-right: 1px dotted #000000;">
									<table border="0" width=93% cellspacing="0" cellpadding="0">
										<tr>
											<td width="100%" style="border-top: 1 solid #000000; border-bottom: 1 solid #000000" bgcolor="#F3F4F5" height="26">
												<p align="left">&nbsp;<b><font color="#003366">Some menu entries</font></b></p>
											</td>
										</tr>
										<tr>
											<td>
												<ul>
												Some links ...
												</ul>
											</td>
										</tr>
										<tr>
											<td width="100%" style="border-top: 1 solid #000000; border-bottom: 1 solid #000000" bgcolor="#F3F4F5" height="26">
												<p align="left">&nbsp;<b><font color="#003366">Some functions</font></b></p>
											</td>
										</tr>
										<tr>
											<!-- The Quick Search Form -->
											<td width="100%" align="center">
												<br>
												<form method="post">
													<input type="text" name="search" size="20">
													<br><br>
													<input type="hidden" name="do" value="search">
													<input type="submit" value="Search">
												</form>
											</td>
											<!-- End of the Search Form -->
										</tr>
									</table>
								</td>
								<!-- <td width=100% valign="top" align="center"> -->
								<td width="1000" valign="top" align="center">
									<table border="0" width="100%" cellspacing="1" cellpadding="3">
										<tr>
											<td>
<?php

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  Here we decide what page to include
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
$extension = ".mp3";
$rows = 0;
$rows_per_col = 10;


if($_POST["do"] == "search" or $_GET["do"] == "search" or $dosearch == "yes"){ 
	$subaction = "search"; 
	$dosearch = "yes"; 
	include("search.php"); 
}

switch( $_GET["do"] ) {
	case  "play": {
		include("$path/readfolder.php"); 
		include("$path/playmp3.php"); 
		echo "<p align=\"center\"><input type=\"button\" value=\"Terug\" onClick=\"history.back()\"></p>"; 
	}
	case  "readfolder": { 
		$foldername = $_GET["foldername"];
		echo "<p align=\"center\"><input type=\"button\" value=\"Previous site\" onClick=\"history.back()\"></p>\n";
		include("readfolder.php"); 
		echo "<p align=\"center\"><input type=\"button\" value=\"Previous site\" onClick=\"history.back()\"></p>\n"; 
		break;
	}
	default: { 
		$foldername = $path; 
		echo "<p align=\"center\"><input type=\"button\" value=\"Previous site\" onClick=\"history.back()\"></p>\n";
		include("readfolder.php"); 
		echo "<p align=\"center\"><input type=\"button\" value=\"Previous site\" onClick=\"history.back()\"></p>\n"; 
		break;
	}
}

?>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
			<table border=0 width=700 style="border-top: 1px dotted #000000;">
				<tr>
					<td>
						<p align="center">Hans-Georg Bork 2011 
					</td>
				</tr>
			</table>
		</div>
	</body>
</html>

